[LeetCode] 1762. Buildings With an Ocean View

There are n buildings in a line. You are given an integer array heights of size n that represents the heights of the buildings in the line.

The ocean is to the right of the buildings. A building has an ocean view if the building can see the ocean without obstructions. Formally, a building has an ocean view if all the buildings to its right have a smaller height.

Return a list of indices (0-indexed) of buildings that have an ocean view, sorted in increasing order.

Example 1:

Input: heights = [4,2,3,1]
Output: [0,2,3]
Explanation: Building 1 (0-indexed) does not have an ocean view because building 2 is taller.

Example 2:

Input: heights = [4,3,2,1]
Output: [0,1,2,3]
Explanation: All the buildings have an ocean view.

Example 3:

Input: heights = [1,3,2,4]
Output: [3]
Explanation: Only building 3 has an ocean view.

Example 4:

Input: heights = [2,2,2,2]
Output: [3]
Explanation: Buildings cannot see the ocean if there are buildings of the same height to its right.

Constraints:

  • 1 <= heights.length <= 105
  • 1 <= heights[i] <= 109

能看到海景的建筑物。

有 n 座建筑物。给你一个大小为 n 的整数数组 heights 表示每一个建筑物的高度。

建筑物的右边是海洋。如果建筑物可以无障碍地看到海洋,则建筑物能看到海景。确切地说,如果一座建筑物右边的所有建筑都比它 矮 时,就认为它能看到海景。

返回能看到海景建筑物的下标列表(下标 从 0 开始 ),并按升序排列。

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/buildings-with-an-ocean-view
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

我这里提供两种思路,一是贪心,二是单调栈。

因为海是在数组的右边,数组最后一个元素是没有被挡住的,所以它有oceanview。照着这个思路,我们从数组的最右边开始往左扫描,如果遇到更高的楼,那么这个更高的楼就是有oceanview的;反之则是没有。

时间O(n)

空间O(n)

Java实现

 1 class Solution {
 2     public int[] findBuildings(int[] heights) {
 3         int max = 0;
 4         List<Integer> list = new ArrayList<>();
 5         for (int i = heights.length - 1; i >= 0; i--) {
 6             if (heights[i] > max) {
 7                 list.add(i);
 8                 max = heights[i];
 9             }
10         }
11 
12         int[] res = new int[list.size()];
13         Collections.reverse(list);
14         for (int i = 0; i < res.length; i++) {
15             res[i] = list.get(i);
16         }
17         return res;
18     }
19 }

 

单调栈其实也是类似的思路,但是单调栈可以让我们从左往右遍历input数组。我们这里做的是一个单调递增的栈。

时间O(n)

空间O(n)

Java实现

 1 class Solution {
 2     public int[] findBuildings(int[] heights) {
 3         Deque<Integer> stack = new ArrayDeque<>();
 4         for (int i = 0; i < heights.length; i++) {
 5             while (!stack.isEmpty() && heights[stack.peekLast()] <= heights[i]) {
 6                 stack.pollLast();
 7             }
 8             stack.addLast(i);
 9         }
10         int n = stack.size();
11         int[] res = new int[n];
12         while (!stack.isEmpty()) {
13             res[--n] = stack.pollLast();
14         }
15         return res;
16     }
17 }

 

LeetCode 题目总结

posted @ 2021-02-27 00:53  CNoodle  阅读(2023)  评论(0编辑  收藏  举报